.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\shell32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\macros\macros.asm

WinMain			PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
NewStar         PROTO :DWORD 
Random          PROTO :DWORD

.const
IDI_ICON      equ 200
NumberOfStars equ 1000 ; No. Stars
StarStructureSize equ 28 ;Size Struct Star
SpeedMin equ 1 ; Low Speed or speedmin
SpeedMax equ 10 ;Max speed or speedmax

.data
ClassName			db 'DLGCLASS',0
DlgName				db 'MyDialog',0
AppName				db 'starfield window',0
EasternStar db FALSE ;Eastern Star Nv
Speed dd 2 ;speed
DisplaysTrolling db TRUE ;Drive type displayed or Displays Trolling
.data?
hIcon     HICON     ?
hInstance HINSTANCE ?
; 
CommandLine			dd ?
hDlg				dd ?
; 
Xwindow dd ? ;window
Ywindow dd ?
Xwindowdiv2 dd ?
Ywindowdiv2 dd ?
hStars HANDLE ? ;H Stars
pStars dd ? ;P Stars
hArrPlan dd ?
RandomNamePr dd ? ;Random Name Pr
rect RECT  <?>

WindowRect      RECT     <?>
MyRect          RECT     <?>
rClientWindow   RECT     <?>
hDialog       HWND ?
.code

start:
mov hInstance,rv(GetModuleHandle,0)
mov    hInstance,eax
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
;  
invoke GetCommandLine
invoke InitCommonControls
invoke WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
; 
invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG
    LOCAL hWnd:HWND
	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke GetStockObject, BLACK_BRUSH
    mov hArrPlan, eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,addr DlgName,NULL,addr WndProc,NULL
	mov hWnd, eax
	invoke ShowWindow,hWnd,SW_SHOWDEFAULT
	invoke UpdateWindow,hWnd
	

	.while TRUE
		  invoke InvalidateRect, hWnd, NULL, FALSE
        invoke GetMessage, ADDR msg, NULL, NULL, NULL
	  .BREAK .if !eax
		INVOKE IsDialogMessage, hDlg, ADDR msg
		.if !eax
			INVOKE TranslateMessage, ADDR msg
			INVOKE DispatchMessage, ADDR msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL hDC:HANDLE
LOCAL hMemDC:HANDLE
LOCAL hBmp:HANDLE
LOCAL ps:PAINTSTRUCT

	.IF uMsg ==WM_CREATE
	INVOKE SetWindowText, hWnd, addr AppName	
	INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon



invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NumberOfStars * StarStructureSize
mov hStars, eax
invoke GlobalLock, hStars
mov pStars, eax
 .ELSEIF uMsg == WM_DESTROY
 
invoke GlobalUnlock, pStars
invoke GlobalFree, hStars
invoke PostQuitMessage, NULL
.ELSEIF uMsg == WM_KEYDOWN
.IF wParam == VK_ESCAPE
invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
.ELSEIF wParam == VK_PGDN
.IF Speed != SpeedMin
dec Speed
.ENDIF
.ELSEIF wParam == VK_PGUP
.IF Speed != SpeedMax
inc Speed
.ENDIF
        .ELSEIF wParam == VK_T
          .IF DisplaysTrolling
            mov DisplaysTrolling, FALSE
          .ELSE
            mov DisplaysTrolling, TRUE
          .ENDIF
        .ENDIF
      .ELSEIF uMsg == WM_PAINT
      INVOKE  GetClientRect,hWnd,ADDR rect
m2m Xwindow,rect.right
m2m Ywindow,rect.bottom

 mov eax,Xwindow
 shr eax, 1 ; This gets the center point of screen to start starfield
mov Xwindowdiv2, eax
      mov eax,Ywindow
      shr eax, 1 ; This gets the center point of screen to start starfield
mov Ywindowdiv2, eax   
        invoke BeginPaint, hWnd, ADDR ps
        mov hDC, eax
        invoke CreateCompatibleDC, hDC
        mov hMemDC, eax
        invoke CreateCompatibleBitmap, hDC, Xwindow, Ywindow
        mov hBmp, eax
        invoke SelectObject, hMemDC, hBmp
        invoke FillRect, hMemDC, OFFSET rect, hArrPlan
        xor ecx, ecx
        .WHILE ecx != NumberOfStars ;NbEtoile=No. Stars
          mov eax, StarStructureSize ;StarStructureSize=Size Struct Star
          mul ecx
          add eax, pStars
          mov ebx, eax
          ;----------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
          mov eax, Speed
          .IF dword ptr [ebx + 8] <= eax
            push ecx
            invoke NewStar, ebx  ;NewStar=New Star
            pop ecx
            mov EasternStar, TRUE
          .ENDIF
          ;----------------------------------------------;
          ;--- REPLACEMENT OF OLD ADDRESS ---;
          .IF DisplaysTrolling ; DisplaysTrolling=Displays Trolling or Drive type displayed???
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
          .ENDIF
          ;----------------------------------------;
          ;--- CALCULATION OF NEW ADDRESS ---;
          mov eax, Speed     ; Speed = Speed
          sub dword ptr [ebx + 8], eax
          mov eax, dword ptr [ebx]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Xwindowdiv2
          mov dword ptr [ebx + 12], eax
          mov eax, dword ptr [ebx + 4]
          shl eax, 8
          cdq
          idiv dword ptr [ebx + 8]
          add eax, Ywindowdiv2
          mov dword ptr [ebx + 16], eax
          ;---------------------------;
          ;--- CORRECTION OF BUGS ---;
          .IF DisplaysTrolling && EasternStar ;Eastern Star Nv
            push dword ptr [ebx + 12]
            pop dword ptr [ebx + 20]
            push dword ptr [ebx + 16]
            pop dword ptr [ebx + 24]
            mov EasternStar, FALSE
          .ENDIF
          ;--------------------------------------------------------------------;
          ;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
          mov eax, Xwindow
          mov edx, Ywindow    ;fenetre=window
          .IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
            mov dword ptr [ebx + 8], 0
          .ENDIF
          push ecx
          ;---------------------------;
          ;--- COLOR OF THE STAR ---;
          xor eax, eax
          mov ah, cl
          mov al, ah
          shl eax, 8
          mov al, ah
          invoke CreatePen, PS_SOLID, NULL, eax
          push eax
          invoke SelectObject, hMemDC, eax
          ;--------------------------;
          ;--- DRAWING FROM THE STAR ---;
          push NULL
          .IF DisplaysTrolling
            push dword ptr [ebx + 24]
            push dword ptr [ebx + 20]
          .ELSE
            mov eax, dword ptr [ebx + 16]
            inc eax
            push eax
            push dword ptr [ebx + 12]
          .ENDIF
          push hMemDC
          call MoveToEx
          invoke LineTo, hMemDC, dword ptr [ebx + 12], dword ptr [ebx + 16]
          pop eax
          invoke DeleteObject, eax
          pop ecx
          inc ecx
        .ENDW
        invoke BitBlt, hDC, 0, 0, Xwindow, Ywindow, hMemDC, 0, 0, SRCCOPY
        invoke DeleteObject, hBmp
        invoke DeleteDC, hMemDC
        invoke EndPaint, hWnd, ADDR ps
      .ELSE
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
      .ENDIF
      xor eax, eax
      ret
WndProc endp
NewStar PROC uses ebx pStar:DWORD
mov ebx, pStar
invoke Random, Xwindow
sub eax, Xwindowdiv2
mov dword ptr [ebx], eax
invoke Random, Ywindow
sub eax, Ywindowdiv2
mov dword ptr [ebx + 4], eax
mov dword ptr [ebx + 8], 256
push Xwindowdiv2
pop dword ptr [ebx + 12]
push Ywindowdiv2
pop dword ptr [ebx + 16]
mov eax, pStar
ret
NewStar ENDP 

Random PROC Limit:DWORD
mov eax, RandomNamePr
mov ecx, 23
mul ecx
add eax, 7
and eax, 0FFFFFFFFh
ror eax, 1
xor eax, RandomNamePr
mov RandomNamePr, eax
mov ecx, Limit 
xor edx, edx
div ecx
mov eax, edx
ret
Random ENDP
end start
